#ifndef __QTFTEMEM_H
#define __QTFTEMEM_H

#include "unimem.h"

// We don't add entries to the binary tree due to 2 reasons:
// 1.	QTFTE should be cleaner and shouldn't require memory leak debugging.
// 2.	It would require MUTEXes and I am not in a mood to do some portable
//		WIN32/Posix hacking.
//
// We do redefine all t* memory macros. We still want memory usage tracking 
// in block headers. QTFTE should use only the t* macros for memory allocations.
// The itsy bitsy memory allocated for the C++ objects is neglected in memory
// tracking.
//
// Arpad Buermen

#undef tmalloc
#undef trealloc
#undef tfree
#undef copy

#define tmalloc(a) malloc_pj((a), NULL, 0, 0)
#define trealloc(a,b) realloc_pj((a), (b), NULL, 0, 0)
#define tfree(a) {free_pj((a), NULL, 0, 0); (a) = NULL;}

#endif
